require File.dirname(__FILE__) + "/../../../../lib/ext/core/integer"

describe Integer do
  context "calculate the sequence up to a given integer" do
    it "starts out with a base value of 1" do
      1.closest_fibonacci.should == 1
    end
    it "returns 0 if supplied with 0" do
      0.closest_fibonacci.should == 0
    end
    it "returns 1 if supplied with 2" do
      2.closest_fibonacci.should == 1
    end

    it "returns 2 if supplied with an upper bound of 3" do
      3.closest_fibonacci.should == 2
    end

    it "returns 3 if supplied with an upper bound of 4" do
      4.closest_fibonacci.should == 3
    end

    it "returns 2 if supplied with an upper bound of 3" do
      21.closest_fibonacci.should == 13
    end

    it "can come up with really large fibonacci numbers since its not recursive and won't break the stack" do
      503240000.closest_fibonacci == 433494437
    end

    it "throws an error if self is negative" do
      lambda{-1.closest_fibonacci}.should raise_error(InvalidArgumentError, "Cannot be less than zero")
    end
  end
end
